;******************************
;* Program Demo GLCD DV128064 *
;* Display Character Thai,Eng *
;* Code Thai KU               *
;* Run Program THAI.COM       *
;* Set     Ե 3 ̲ݸ         *
;*         ǾԵ СƳ   *
;*         ԿਲШ         *
;* Assembler : A180Z          *
;* Hardware  : CP-JR180V1     *
;* BY...ETT CO.,LTD.(14/7/97) *
;******************************
;
            .EQU     COUN_C,16      ;set 16 char
;    FOR LCD
            .EQU     LCDCTRL1,0C0H
            .EQU     LCDCTRL2,0C1H
            .EQU     LCDDATA1,0C2H
            .EQU     LCDDATA2,0C3H
            .EQU     LCDREAD1,0C4H
            .EQU     LCDREAD2,0C5H
;
            .EQU     STARTLN0,0C0H
            .EQU     LINE1,0B8H
            .EQU     LINE2,0B9H
            .EQU     LINE3,0BAH
            .EQU     LINE4,0BBH
            .EQU     LINE5,0BCH
            .EQU     LINE6,0BDH
            .EQU     LINE7,0BEH
            .EQU     LINE8,0BFH

            .EQU     DISPON,3FH
            .EQU     DISPOFF,3EH
            .EQU     STARTCL0,40H
;
;
;*******************************
;    I/O CPU Z80180            *
;*******************************
;*** ASCI ***
        .EQU   FR1,0DBH
        .EQU   FR2,0B0H
        .EQU   CNTLA0,0
        .EQU   CNTLA1,1
        .EQU   CNTLB0,2
        .EQU   CNTLB1,3
        .EQU   STAT0,4
        .EQU   STAT1,5
        .EQU   TDR0,6
        .EQU   TDR1,7
        .EQU   RDR0,8
        .EQU   RDR1,9
;
;*** CSI/O ***

        .EQU   CNTR,0AH
        .EQU   TRDR,0BH
;
;*** TIMER ***

        .EQU   TMDR0L,0CH
        .EQU   TMDR0H,0DH
        .EQU   RLDR0L,0EH
        .EQU   RLDR0H,0FH
        .EQU   TCR,10H
        .EQU   TMDR1L,14H
        .EQU   TMDR1H,15H
        .EQU   RLDR1L,16H
        .EQU   RLDR1H,17H
;
;*** OTHER ***

        .EQU   FRC,18H
;
;*** DMA ***

        .EQU   SAR0L,20H
        .EQU   SAR0H,21H
        .EQU   SAR0B,22H
        .EQU   DAR0L,23H
        .EQU   DAR0H,24H
        .EQU   DAR0B,25H
        .EQU   BCR0L,26H
        .EQU   BCR0H,27H
        .EQU   MAR1L,28H
        .EQU   MAR1H,29H
        .EQU   MAR1B,2AH
        .EQU   IAR1L,2BH
        .EQU   IAR1H,2CH
        .EQU   BCR1L,2EH
        .EQU   BCR1H,2FH
        .EQU   DSTAT,30H
        .EQU   DMODE,31H
        .EQU   DCNTL,32H
;
;*** INT ***

        .EQU   IL,33H
        .EQU   ITC,34H
;
;*** REFRESH ***

        .EQU   RCR,36H
;
;*** MMU ***

        .EQU   CBR,38H
        .EQU   BBR,39H
        .EQU   CBAR,3AH
;
;*** I/O ***
;
        .EQU   OMCR,3EH
        .EQU   ICR,3FH
;
;       END    I/O MAP REG 80180
;**********************************
;
; ********** POWER-UP **********
;
               .ORG     0000H
;
INIT:           LD HL,0000H
INIT1:          DEC HL
                LD  A,H
                OR  L
                JP  NZ,INIT1
;
INIT2:          LD   A,0F8H         ;
                OUT0 (CBAR),A       ;MONITOR 0-7FFF NOT REMOVE
                LD   A,8H           ;ram 08000h-0ffffh=10000h
                OUT0 (BBR),A
                OUT0 (CBR),A
;
;*** SET INITIAL INTERNAL I/O ***
;
                LD   A,40H
                OUT0 (OMCR),A       ;SAME Z80
                LD   A,83H
                OUT0 (RCR),A        ;ENABLE REFRESH
                IN0  A,(DCNTL)
                OR   70H
                OUT0 (DCNTL),A      ;MEM 2 WIAT  IO 4
;
                LD   SP,0FFFFH                  ;STACK
                LD   A,0
                LD   I,A
                LD   A,40H
                OUT0 (IL),A

;******************************
;        RUN PROGRAM
;
RUN:            CALL INITLCD        ;INIT GLCD SET DISPLAY ON
                CALL CLRSCR         ;CLS SCREEN GLCD PADG1,PAGE2
;
               LD   IY,TAB_1
               CALL LINE10
               LD   IY,TAB_2
               CALL LINE20
               LD   IY,TAB_3
               CALL LINE30
               LD   IY,TAB_4
               CALL LINE40
               CALL DELAY
;
               LD   IY,TAB_5
               CALL LINE10
               LD   IY,TAB_6
               CALL LINE20
               LD   IY,TAB_7
               CALL LINE30
               LD   IY,TAB_8
               CALL LINE40
               CALL DELAY
               CALL DELAY
;
               LD   IY,TAB_9
               CALL LINE10
               LD   IY,TAB_10
               CALL LINE20
               LD   IY,TAB_11
               CALL LINE30
               LD   IY,TAB_12
               CALL LINE40
               CALL DELAY
;
               LD   IY,TAB_13
               CALL LINE10
               LD   IY,TAB_14
               CALL LINE20
               LD   IY,TAB_15
               CALL LINE30
               LD   IY,TAB_16
               CALL LINE40
               CALL DELAY
;
               LD   IY,TAB_17
               CALL LINE10
               LD   IY,TAB_18
               CALL LINE20
               LD   IY,TAB_19
               CALL LINE30
               LD   IY,TAB_20
               CALL LINE40
               CALL DELAY
;
               LD   IY,TAB_21
               CALL LINE10
               LD   IY,TAB_22
               CALL LINE20
               LD   IY,TAB_23
               CALL LINE30
               LD   IY,TAB_24
               CALL LINE40
               CALL DELAY
;
               LD   IY,TAB_25
               CALL LINE10
               LD   IY,TAB_26
               CALL LINE20
               LD   IY,TAB_27
               CALL LINE30
               LD   IY,TAB_28
               CALL LINE40
               CALL DELAY
;
               JP   RUN

;***********************************
;                1234567890123456
;***** main menu *******************
;
TAB_1:      .DB "  ױοӨη ",0
TAB_2:      .DB "Եݸ LCD Բ",0
TAB_3:      .DB "Ҳ Բײ ",0
TAB_4:      .DB "ҹѡ ǲ  ",0
;
TAB_5:      .DB "ԵΡ ڵڵ. ",0
TAB_6:      .DB " .. ݸ",0
TAB_7:      .DB "GRAPHIC LCD     ",0
TAB_8:      .DB "DV-12864 Ρڵڵ ",0
;
TAB_9:      .DB "Тҹѡ  ",0
TAB_10:     .DB "οТ  ",0
TAB_11:     .DB "ԵТӷҹѡ ",0
TAB_12:     .DB "ԲҲѸ..  ",0
;
TAB_13:     .DB " run thai.com ",0
TAB_14:     .DB "ġТТ ",0
TAB_15:     .DB "ԵТӷҹѡ ",0
TAB_16:     .DB "ԲҲ......  ",0
;
TAB_17:     .DB "ΥТ   ",0
TAB_18:     .DB "    LD  IY,T1   ",0
TAB_19:     .DB "    CALL LINE10 ",0
TAB_20:     .DB "T1: .DB  Ե",0
;

TAB_21:     .DB "ҹѡ̦ݲ   ",0
TAB_22:     .DB "̲ݸԵ 3 ̲ݸ",0
TAB_23:     .DB "ӨԵ СƳ  ",0
TAB_24:     .DB " Ρ ڵڵ... ",0
;

TAB_25:     .DB " ETT CO.,LTD.   ",0
TAB_26:     .DB " TEL 7121120-1  ",0
TAB_27:     .DB " FAX 3917216    ",0
TAB_28:     .DB " www.ett.co.th  ",0
;
;******************************
; DISPLAY LINE1 1-16          *
; INPUT IY=TABLE DISPLAY      *
; LINE10 =LINE1               *
; LINE20 =LINE2               *
; LINE30 =LINE3               *
; LINE40 =LINE4               *
;******************************
LINE10:     CALL PAGE1
            LD   A,0
            LD   (X_BUF),A   ;LINE 1
            CALL  LINE16_D
            RET
;
; DISPLAY LINE2 1-16
LINE20:      CALL PAGE1
            LD   A,2
            LD   (X_BUF),A
            CALL  LINE16_D
            RET
;
; DISPLAY LINE3 1-16
LINE30:      CALL PAGE1
            LD   A,4
            LD   (X_BUF),A
            CALL  LINE16_D
            RET
;
; DISPLAY LINE4 1-16
LINE40:      CALL PAGE1
            LD   A,6
            LD   (X_BUF),A
            CALL  LINE16_D
            RET
;
;  SUB PRO LINEX
;
LINE16_D:   LD   (X_BUF),A   ;LINE 1
            LD   A,0
            LD   (Y_BUF),A
            LD   HL,TAB_ENG
            LD   (SAVE_HL),HL
            CALL DISP_T
            CALL DISPLAY1    ;DISPLAY BUFFER 16 CHAR
            RET
;
;*************************
; DISPLAY LINE4 1-16     *
;*************************
LINE1U:     CALL PAGE1
            LD   A,0
            LD   (X_BUF),A
            CALL  LINE1U_D
            RET
;
;  SUB PRO LINEX
;
LINE1U_D:   LD   (X_BUF),A   ;LINE 1
            LD   A,0
            LD   (Y_BUF),A
            LD   HL,TAB_ENG
            LD   (SAVE_HL),HL
            CALL DISP_T
            CALL SET_ULINE   ;SET "-"
            CALL DISPLAY1    ;DISPLAY BUFFER 16 CHAR
            RET
;
;*************************
; DISPLAY LINE4 1-16     *
;*************************
LINE1I:     CALL PAGE1
            LD   A,0
            LD   (X_BUF),A
            CALL  LINE1I_D
            RET
;
;  SUB PRO LINEX
;
LINE1I_D:   LD   A,0
            LD   (Y_BUF),A
            LD   HL,TAB_ENG
            LD   (SAVE_HL),HL
            CALL DISP_T
            CALL DISPLAY1    ;DISPLAY BUFFER 16 CHAR
            RET
;
;******************************
; DISPLAY LINE1 1-8           *
; INPUT IY=TABLE DISPLAY      *
;******************************
LINE1_1:    CALL PAGE1
            LD   A,0
            LD   (X_BUF),A   ;LINE 1
            CALL  LINE8_D
            RET
;
; DISPLAY  LINE1 9-16
;
LINE1_2:    CALL PAGE2
            LD   A,0
            LD   (X_BUF),A   ;LINE 1
            CALL  LINE8_D
            RET
;
; DISPLAY LINE2 1-8
LINE2_1:    CALL PAGE1
            LD   A,2
            LD   (X_BUF),A
            CALL  LINE8_D
            RET
;
; DISPLAY LINE2 9-16
LINE2_2:    CALL PAGE2
            LD   A,2
            LD   (X_BUF),A
            CALL  LINE8_D
            RET
;
; DISPLAY LINE3 1-8
LINE3_1:    CALL PAGE1
            LD   A,4
            LD   (X_BUF),A
            CALL  LINE8_D
            RET
;
; DISPLAY LINE3 9-16
LINE3_2:    CALL PAGE2
            LD   A,4
            LD   (X_BUF),A
            CALL  LINE8_D
            RET
;
;
; DISPLAY LINE4 1-8
LINE4_1:    CALL PAGE1
            LD   A,6
            LD   (X_BUF),A
            CALL  LINE8_D
            RET
;
; DISPLAY LINE4 9-16
LINE4_2:    CALL PAGE2
            LD   A,6
            LD   (X_BUF),A
            CALL  LINE8_D
            RET
;
;  SUB PRO LINEX_X
;
LINE8_D:    LD   (X_BUF),A   ;LINE 1
            LD   A,0
            LD   (Y_BUF),A
            LD   HL,TAB_ENG
            LD   (SAVE_HL),HL
            CALL DISP_T
            CALL DISPLAY2
            RET

;*******************************************
;     INPUT IY=TABLE PRINT TO LCD          *
;              END=00                      *
;*******************************************
;
DISP_T:     CALL CLR_BUFD      ;CLEAR BUF DIS1 DIS2
            XOR  A
            LD   (COUN_DIS),A  ;SET COUNTER CHAR DISPLAY=0
;
            LD   DE,BUF_DIS1   ;BUFFER 1
            LD   (P_DIS1),DE
            LD   DE,BUF_DIS2
            LD   (P_DIS2),DE
;

DISP_L:     LD  HL,(SAVE_HL)
            LD  A,(IY+0)
            CP  0
            JP  Z,DIS_TE
            SUB 20H
            LD  B,A
            CP  0
            JP  Z,DIS_TX
DIS_T1:     LD   DE,0008H
            ADD  HL,DE
            DEC B
            JP NZ,DIS_T1

DIS_TX:     PUSH HL            ;LD IX,HL
            POP  IX

            LD   A,(IY+0)
;
            CP   0D7H          ;  
            JP   Z,CON_UU
            CP   0D8H
            JP   Z,CON_UU
            JP   CON_MO1

CON_UU:     CALL CONVER_U
            JP   CONV_SS

CON_MO1:    CP   0D9H
            JP   NC,CON_OO       ;>= 0D9
            JP   COU_O2
;
CON_OO:     CALL CONVER_O
            JP   CONV_SS
;
COU_O2:     LD   A,(COUN_DIS)
            CP   00H
            JP   Z,CON_DIG1
;
            LD   DE,(P_DIS1)   ;ADD + BUF DIS
            LD   HL,8
            ADD  HL,DE
            LD   (P_DIS1),HL
            LD   DE,(P_DIS2)
            LD   HL,8
            ADD  HL,DE
            LD   (P_DIS2),HL
;
;
CON_DIG1:   CALL CONVER_C      ;INPUT IX   CONVER CHAR
            LD   A,(COUN_DIS)
            INC  A
            LD   (COUN_DIS),A
;
CONV_SS:    INC  IY
            JP   DISP_L

DIS_TE:     RET
;
;*****************************
; DISPLAY DIS1 DIS2 8 BYTE   *
; INPUT BUF_DIS1,BUF_DIS2    *
;*****************************
;
DISPLAY2:   PUSH AF
            PUSH BC
            PUSH IX
            PUSH HL
;
            LD   A,(X_BUF)    ;GOTO X,Y
            OR   10111000B
            CALL GOTOLINE
            LD   A,(Y_BUF)
            CALL GOTO_Y
;
            LD   IX,BUF_DIS1
            LD   A,(COUN_DIS) ;DATA COUNTER CHAR
            LD   C,A
            LD   B,8H
            MLT  BC           ;8 X COUNTER
            LD   B,C
            LD   A,(DPORT)
            LD   C,A
;
OUTDA21:    LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
;
OUTDX2_1:   DEC  B
            JP   NZ,OUTDA21
;
            LD   E,0
            LD   A,(X_BUF)     ;GOTO (X_BUF)+1 LINE
            INC  A
            OR   10111000B
            CALL GOTOLINE
            LD   A,(Y_BUF)
            CALL GOTO_Y
;
            LD   IX,BUF_DIS2
            LD   A,(COUN_DIS) ;DATA COUNTER CHAR
            LD   C,A
            LD   B,8H
            MLT  BC           ;8 X COUNTER
            LD   B,C
            LD   A,(DPORT)
            LD   C,A
OUTX22:     LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
;
OUTDY2_2:   DEC  B
            JP   NZ,OUTX22

            POP  HL
            POP  IX
            POP  BC
            POP  AF
            RET
;
;****************************
; DISPLAY DIS1 DIS2 16 BYTE *
; INPUT BUF_DIS1,BUF_DIS2   *
;****************************
;
DISPLAY1:   PUSH AF
            PUSH BC
            PUSH IX
            PUSH HL
;
            LD   A,(X_BUF)    ;GOTO X,Y
            OR   10111000B
            CALL GOTOLINE
            LD   A,(Y_BUF)
            CALL GOTO_Y
;
            LD   IX,BUF_DIS1
            LD   B,64          ;8 X8
            LD   A,(DPORT)
            LD   C,A

OUTDA11:    LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
;
            DEC  B
            JP   NZ,OUTDA11
;
            LD   E,0
            LD   A,(X_BUF)     ;GOTO (X_BUF)+1 LINE
            INC  A
            OR   10111000B
            CALL GOTOLINE
            LD   A,(Y_BUF)
            CALL GOTO_Y
;
            LD   IX,BUF_DIS2
            LD   B,64
            LD   A,(DPORT)
            LD   C,A
OUTX12:     LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
;
            DEC  B
            JP   NZ,OUTX12
;
            CALL PAGE2
            LD   A,(X_BUF)    ;GOTO X,Y
            OR   10111000B
            CALL GOTOLINE
            LD   A,(Y_BUF)
            CALL GOTO_Y
;
            LD   IX,BUF_DIS1+((COUN_C*8)/2)
            LD   B,64
            LD   A,(DPORT)
            LD   C,A

OUTDA1X:    LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
;
            DEC  B
            JP   NZ,OUTDA1X
;----------
            LD   E,0
            LD   A,(X_BUF)     ;GOTO (X_BUF)+1 LINE
            INC  A
            OR   10111000B
            CALL GOTOLINE
            LD   A,(Y_BUF)
            CALL GOTO_Y
;
            LD   IX,BUF_DIS2+((COUN_C*8)/2)
            LD   A,(COUN_DIS) ;DATA COUNTER CHAR
            LD   B,64
            LD   A,(DPORT)
            LD   C,A
OUTX1X:     LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
;
            DEC  B
            JP   NZ,OUTX1X
;
            POP  HL
            POP  IX
            POP  BC
            POP  AF
            RET
;
;*****************************
; CLEAR BUF DIS1 , DIS2      *
;*****************************
;
CLR_BUFD:   PUSH HL
            PUSH DE
            PUSH BC
            LD   HL,BUF_DIS1
            LD   DE,BUF_DIS1+1
            LD   BC,16*COUN_C       ;XXX
            LD   (HL),0
            LDIR
            POP  BC
            POP  DE
            POP  HL
            RET
;
;**********************************
; SET UNDEL LINE BUF DIS1 , DIS2  *
;**********************************
;
SET_ULINE:  PUSH HL
            PUSH DE
            PUSH BC
            LD   HL,BUF_DIS2
            LD   BC,8*COUN_C       ;XXX
SET_U1:     SET  7,(HL)
            INC  HL
            DEC  BC
            LD   A,B
            OR   C
            JP   NZ,SET_U1
            POP  BC
            POP  DE
            POP  HL
            RET
;
;
DISP8:      LD   B,8
DISP8_1:    LD   (STBMAP),HL
            CALL DISPLAY
            LD   DE,0008H
            ADD  HL,DE
            DEC  B
            JP   NZ,DISP8_1
            RET
;
;*********** GOTO Y ADDR 0-63 ************
;    Y ADDR 0-63                         *
;    INPUT LINE REG (A)                  *
;*****************************************
;
GOTO_Y:     PUSH AF
            LD   A,(CPORT)
            LD   C,A
            POP  AF
            RES  7,A    ;SET CODE  01XXXXXX  COMMAND Y-ADDR
            SET  6,A
            OUT  (C),A
            CALL WBF
            RET
;
;*********** GOTO LINE# COL 1 ***********
;    SET LINE #                         *
;    INPUT LINE REG (A)                 *
;****************************************
;
GOTOLINE:   PUSH AF
            LD   A,(CPORT)
            LD   C,A
            POP  AF
            OUT  (C),A
            CALL WBF
            LD   A,STARTCL0
            OUT  (C),A
            RET
;
;*************************************
; CONVER  UNDER CHAR                 *
; INPUT   = (IX)                     *
; OUTPUT  = MEN BUF_DIS2             *
;*************************************
;
CONVER_U:   PUSH IX
            PUSH HL
            PUSH BC

            LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_U1:     LD  A,C
            AND (IX+0)
            JR  Z,CON_U100
            SET 5,(HL)
            JR  CON_UE100
CON_U100:   RES 5,(HL)
CON_UE100:  INC HL
            RRC C
            DJNZ CON_U1
            INC IX

            LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_U2:     LD  A,C
            AND (IX+0)
            JR  Z,CON_U200
            SET 6,(HL)
            JR  CON_UE200
CON_U200:   RES 6,(HL)
CON_UE200:  INC HL
            RRC C
            DJNZ CON_U2
            INC IX

            LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_U3:     LD  A,C
            AND (IX+0)
            JR  Z,CON_U300
            SET 7,(HL)
            JR  CON_UE300
CON_U300:   RES 7,(HL)
CON_UE300:  INC HL
            RRC C
            DJNZ CON_U3

            POP BC
            POP HL
            POP IX
            RET

;*************************************
; CONVER  OVER CHAR                  *
; INPUT   = (IX)                     *
; OUTPUT  = MEN BUF_DIS2             *
;*************************************

CONVER_O:   PUSH IX
            PUSH HL
            PUSH BC
            INC  IX                ;BYTE0
            INC  IX                ;BYTE1
            INC  IX                ;BYTE2
            LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_O1:     LD  A,C
            AND (IX+0)
            JR  Z,CON_O100
            SET 0,(HL)
            JR  CON_OE100
CON_O100:   ;RES 0,(HL)
CON_OE100:  INC HL
            RRC C
            DJNZ CON_O1
            INC IX

            LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_O2:     LD  A,C
            AND (IX+0)
            JR  Z,CON_O200
            SET 1,(HL)
            JR  CON_OE200
CON_O200:   ;RES 1,(HL)
CON_OE200:  INC HL
            RRC C
            DJNZ CON_O2
            INC IX

            LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_O3:     LD  A,C
            AND (IX+0)
            JR  Z,CON_O300
            SET 2,(HL)
            JR  CON_OE300
CON_O300:   ;RES 2,(HL)
CON_OE300:  INC HL
            RRC C
            DJNZ CON_O3
            INC IX

            LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_O4:     LD  A,C
            AND (IX+0)
            JR  Z,CON_O400
            SET 3,(HL)
            JR  CON_OE400
CON_O400:   ;RES 3,(HL)
CON_OE400:  INC HL
            RRC C
            DJNZ CON_O4
            INC IX

            LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_O5:     LD  A,C
            AND (IX+0)
            JR  Z,CON_O500
            SET 4,(HL)
            JR  CON_OE500
CON_O500:   ;RES 4,(HL)
CON_OE500:  INC HL
            RRC C
            DJNZ CON_O5

            POP BC
            POP HL
            POP IX
            RET
;
;*************************************
; CONVER < TO  ^                     *
; INPUT   = (IX)                     *
; OUTPUT  = MEN BUF_DIS1-2           *
;*************************************

CONVER_C:   PUSH IX
            PUSH HL
            PUSH BC

            LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L1:     LD  A,C
            AND (IX+0)
            JR  Z,CON_100
            SET 5,(HL)
            JR  CON_E100
CON_100:    RES 5,(HL)
CON_E100:   INC HL
            RRC C
            DJNZ CON_L1
            INC IX
;
CONVER2:    LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L2:     LD  A,C
            AND (IX+0)
            JR  Z,CON_200
            SET 6,(HL)
            JR  CON_E200
CON_200:    RES 6,(HL)
CON_E200:   INC HL
            RRC C
            DJNZ CON_L2
            INC  IX
;
CONVER3:    LD  HL,(P_DIS1)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L3:     LD  A,C
            AND (IX+0)
            JR  Z,CON_300
            SET 7,(HL)
            JR  CON_E300
CON_300:    RES 7,(HL)
CON_E300:   INC HL
            RRC C
            DJNZ CON_L3
            INC IX
;
CONVER4:    LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L4:     LD  A,C
            AND (IX+0)
            JR  Z,CON_400
            SET 0,(HL)
            JR  CON_E400
CON_400:    RES 0,(HL)
CON_E400:   INC HL
            RRC C
            DJNZ CON_L4
            INC IX
;
CONVER5:    LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L5:     LD  A,C
            AND (IX+0)
            JR  Z,CON_500
            SET 1,(HL)
            JR  CON_E500
CON_500:    RES 1,(HL)
CON_E500:   INC HL
            RRC C
            DJNZ CON_L5
            INC IX
;
CONVER6:    LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L6:     LD  A,C
            AND (IX+0)
            JR  Z,CON_600
            SET 2,(HL)
            JR  CON_E600
CON_600:    RES 2,(HL)
CON_E600:   INC HL
            RRC C
            DJNZ CON_L6
            INC IX
;
CONVER7:    LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L7:     LD  A,C
            AND (IX+0)
            JR  Z,CON_700
            SET 3,(HL)
            JR  CON_E700
CON_700:    RES 3,(HL)
CON_E700:   INC HL
            RRC C
            DJNZ CON_L7
            INC IX
;
CONVER8:    LD  HL,(P_DIS2)
            LD  B,8
            LD  C,10000000B         ;BIT 0
CON_L8:     LD  A,C
            AND (IX+0)
            JR  Z,CON_800
            SET 4,(HL)
            JR  CON_E800
CON_800:    RES 4,(HL)
CON_E800:   INC HL
            RRC C
            DJNZ CON_L8

            POP BC
            POP HL
            POP IX
            RET

;**********************************
;  SET PAGE USER 1 ******         *
;**********************************
;
PAGE1:      PUSH AF
            LD   A,LCDCTRL1
            LD   (CPORT),A
            LD   A,LCDDATA1
            LD   (DPORT),A
            LD   A,LCDREAD1
            LD   (RPORT),A
            POP  AF
            RET

;************************
;* SET PAGE USER 2      *
;************************
;
PAGE2:      PUSH AF
            LD   A,LCDCTRL2
            LD   (CPORT),A
            LD   A,LCDDATA2
            LD   (DPORT),A
            LD   A,LCDREAD2
            LD   (RPORT),A
            POP  AF
            RET

;******************************
;*  CLEAR SCREEN              *
;*  CLEAR SCREEN PAGE1,PAGE2  *
;******************************
CLRSCR:     PUSH AF
            CALL PAGE1
            LD   A,STARTLN0
            CALL GOTOLINE
            CALL CLEAR
            CALL PAGE2
            LD   A,STARTLN0
            CALL GOTOLINE
            CALL CLEAR
            POP AF
            RET

;*********************************
; CLEAR SCREEN                   *
; SUB PROGRAM CLRSCR             *
;*********************************
CLEAR:      PUSH DE
            PUSH BC
            PUSH AF
            LD E,LINE1
            LD D,08H
ANOTHER:    LD A,(CPORT)
            LD C,A
            LD A,E
            CALL WBF
            OUT (C),A
            LD   B,48H
            LD   A,(DPORT)
            LD   C,A
LLC:        LD   A,0H ;XXX
            OUT  (C),A
            CALL WBF
            DEC  B
            JP   NZ,LLC
            INC  E
            DEC  D
            LD   A,00H
            CP   D
            JP   NZ,ANOTHER
            POP  AF
            POP  BC
            POP  DE
            RET

;*********************
;*    INIT  LCD      *
;*********************
;
INITLCD:    CALL PAGE1
            LD   A,(CPORT)
            LD   C,A
            LD   A,DISPON
            OUT  (C),A
            CALL WBF
            LD   A,STARTLN0
            OUT  (C),A
            CALL WBF
;
            CALL PAGE2
            LD   A,(CPORT)
            LD   C,A
            LD   A,DISPON
            OUT  (C),A
            CALL WBF
            LD   A,STARTLN0
            OUT  (C),A
            CALL WBF
            RET

;*******************************
;  CHECK BUSY FLAG LCD         *
;*******************************
;
WBF:        PUSH AF
            PUSH BC
            PUSH DE
BUSY1:      LD   A,(RPORT)
            LD   C,A
            IN   A,(C)
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            BIT  7,A
            JP   NZ,BUSY1
            POP  DE
            POP  BC
            POP  AF
            RET

;************* DISPLAY LCD ONE CHAR ***********
;   DISPLAY ONE CHAR = 8 BYTE                 *
;   INPUT DATA  = (STBMAP)                    *
;**********************************************
DISPLAY:    PUSH AF
            PUSH BC
            PUSH IX
            LD   IX,(STBMAP)
            LD   B,08H
            LD   A,(DPORT)
            LD   C,A
OUTDAT:     LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
            DEC  B
            JP   NZ,OUTDAT
            POP  IX
            POP  BC
            POP  AF
            RET
;
;**************************
;    DELAY PROGRAM
;**************************
;
DELAY:      LD    HL,5000H         ; DELAY
DEL_S1:     DEC   HL
            LD    A,70
DELL2:      DEC   A
            JP    NZ,DELL2
            LD    A,L
            OR    H
            JP    NZ,DEL_S1
            RET
;
;*******************************
;    DATA CHR ENG AND THAI KU  *
;*******************************
;
TAB_ENG:
  .DB   00H,00H,00H,00H,00H,00H,00H,00H,10H,38H,38H,10H,10H,00H,10H,00H
  .DB   24H,24H,24H,00H,00H,00H,00H,00H,24H,24H,7EH,24H,7EH,24H,24H,00H
  .DB   04H,3EH,48H,3CH,12H,7CH,20H,00H,00H,62H,94H,68H,10H,2CH,52H,8CH
  .DB   30H,48H,30H,56H,88H,88H,76H,00H,30H,10H,60H,00H,00H,00H,00H,00H
  .DB   10H,20H,40H,40H,40H,20H,10H,00H,20H,10H,08H,08H,08H,10H,20H,00H
  .DB   00H,44H,28H,0D6H,28H,44H,00H,00H,00H,10H,10H,7CH,10H,10H,00H,00H
  .DB   00H,00H,00H,00H,00H,30H,10H,60H,00H,00H,00H,7EH,00H,00H,00H,00H
  .DB   00H,00H,00H,00H,00H,10H,10H,00H,00H,02H,04H,08H,10H,20H,40H,00H
  .DB   3CH,42H,46H,4AH,52H,62H,3CH,00H,10H,30H,10H,10H,10H,10H,7CH,00H
  .DB   3CH,42H,02H,0CH,30H,42H,7EH,00H,3CH,42H,02H,1CH,02H,42H,3CH,00H
  .DB   08H,18H,28H,48H,0FEH,08H,1CH,00H,7EH,40H,7CH,02H,02H,42H,3CH,00H
  .DB   1CH,20H,40H,7CH,42H,42H,3CH,00H,7EH,42H,04H,08H,10H,10H,10H,00H
  .DB   3CH,42H,42H,3CH,42H,42H,3CH,00H,3CH,42H,42H,3EH,02H,04H,78H,00H
  .DB   00H,10H,10H,00H,00H,10H,10H,00H,00H,10H,10H,00H,00H,10H,10H,20H
  .DB   08H,10H,20H,40H,20H,10H,08H,00H,00H,00H,7EH,00H,00H,7EH,00H,00H
  .DB   10H,08H,04H,02H,04H,08H,10H,00H,3CH,42H,02H,04H,08H,00H,08H,00H
  .DB   3CH,42H,4AH,52H,4CH,40H,3EH,00H,18H,24H,42H,42H,7EH,42H,42H,00H
  .DB   7CH,22H,22H,3CH,22H,22H,7CH,00H,1CH,22H,40H,40H,40H,22H,1CH,00H
  .DB   78H,24H,22H,22H,22H,24H,78H,00H,7EH,22H,28H,38H,28H,22H,7EH,00H
  .DB   7EH,22H,28H,38H,28H,20H,70H,00H,1CH,22H,40H,4EH,42H,26H,1AH,00H
  .DB   42H,42H,42H,7EH,42H,42H,42H,00H,38H,10H,10H,10H,10H,10H,38H,00H
  .DB   0EH,04H,04H,04H,04H,0C4H,78H,00H,62H,24H,28H,30H,28H,24H,62H,00H
  .DB   70H,20H,20H,20H,20H,22H,7EH,00H,44H,0AAH,92H,92H,92H,82H,82H,00H
  .DB   42H,62H,52H,4AH,46H,42H,42H,00H,18H,24H,42H,42H,42H,24H,18H,00H
  .DB   7CH,22H,22H,3CH,20H,20H,70H,00H,3CH,42H,42H,42H,4AH,44H,3AH,00H
  .DB   7CH,22H,22H,3CH,28H,24H,72H,00H,3CH,42H,20H,18H,04H,42H,3CH,00H
  .DB   7FH,49H,08H,08H,08H,08H,1CH,00H,42H,42H,42H,42H,42H,42H,3CH,00H
  .DB   41H,41H,41H,41H,22H,14H,08H,00H,41H,41H,49H,49H,49H,55H,22H,00H
  .DB   41H,22H,14H,08H,14H,22H,41H,00H,41H,22H,14H,08H,08H,08H,1CH,00H
  .DB   7FH,42H,04H,08H,10H,21H,7FH,00H,78H,40H,40H,40H,40H,40H,78H,00H
  .DB   80H,40H,20H,10H,08H,04H,02H,00H,78H,08H,08H,08H,08H,08H,78H,00H
  .DB   10H,28H,44H,82H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,0FFH
  .DB   10H,10H,08H,00H,00H,00H,00H,00H,00H,00H,3CH,02H,3EH,42H,3DH,00H
  .DB   60H,20H,20H,2EH,31H,31H,2EH,00H,00H,00H,3CH,42H,40H,42H,3CH,00H
  .DB   06H,02H,02H,3AH,46H,46H,3BH,00H,00H,00H,3CH,42H,7EH,40H,3CH,00H
  .DB   0CH,12H,10H,38H,10H,10H,38H,00H,00H,00H,3DH,42H,42H,3AH,02H,7CH
  .DB   60H,20H,2CH,32H,22H,22H,62H,00H,10H,00H,30H,10H,10H,10H,38H,00H
  .DB   02H,00H,06H,02H,02H,02H,0C2H,7CH,60H,20H,24H,28H,30H,28H,26H,00H
  .DB   30H,10H,10H,10H,10H,10H,38H,00H,00H,00H,22H,55H,49H,49H,41H,00H
  .DB   00H,00H,5CH,62H,42H,42H,42H,00H,00H,00H,3CH,42H,42H,42H,3CH,00H
  .DB   00H,00H,6CH,32H,32H,2CH,20H,70H,00H,00H,36H,4CH,4CH,34H,04H,0EH
  .DB   00H,00H,6CH,32H,22H,20H,70H,00H,00H,00H,3EH,40H,3CH,02H,7CH,00H
  .DB   10H,10H,7CH,10H,10H,12H,0CH,00H,00H,00H,42H,42H,42H,46H,3AH,00H
  .DB   00H,00H,41H,41H,22H,14H,08H,00H,00H,00H,41H,49H,49H,55H,22H,00H
  .DB   00H,00H,44H,28H,10H,28H,44H,00H,00H,00H,42H,42H,46H,3AH,02H,7CH
  .DB   00H,00H,7CH,08H,10H,20H,7CH,00H,0CH,10H,10H,60H,10H,10H,0CH,00H
  .DB   10H,10H,10H,10H,10H,10H,10H,10H,30H,08H,08H,06H,08H,08H,30H,00H
  .DB   32H,4CH,00H,00H,00H,00H,00H,00H,00H,08H,14H,22H,41H,41H,7FH,00H
  .DB   08H,08H,08H,08H,08H,08H,0CH,0CH,00H,00H,79H,86H,80H,70H,08H,08H
  .DB   00H,00H,3CH,42H,91H,91H,62H,04H,00H,00H,88H,58H,28H,08H,08H,08H
  .DB   42H,00H,38H,04H,3CH,44H,3EH,00H,30H,00H,38H,04H,3CH,44H,3EH,00H
  .DB   10H,00H,38H,04H,3CH,44H,3EH,00H,00H,00H,3CH,40H,40H,3CH,06H,1CH
  .DB   3CH,42H,3CH,42H,7EH,40H,3CH,00H,42H,00H,3CH,42H,7EH,40H,3CH,00H
  .DB   30H,00H,3CH,42H,7EH,40H,3CH,00H,24H,00H,18H,08H,08H,08H,1CH,00H
  .DB   7CH,82H,30H,10H,10H,10H,38H,00H,30H,00H,18H,08H,08H,08H,1CH,00H
  .DB   42H,18H,24H,42H,7EH,42H,42H,00H,18H,18H,00H,3CH,42H,7EH,42H,00H
  .DB   0CH,00H,7CH,20H,38H,20H,7CH,00H,00H,00H,33H,0CH,3FH,44H,3BH,00H
  .DB   1FH,24H,44H,7FH,44H,44H,47H,00H,18H,24H,00H,3CH,42H,42H,3CH,00H
  .DB   00H,42H,00H,3CH,42H,42H,3CH,00H,00H,00H,00H,00H,1FH,18H,18H,18H
  .DB   00H,00H,00H,00H,0FFH,18H,18H,18H,00H,00H,00H,00H,0F8H,18H,18H,18H
  .DB   18H,18H,18H,18H,1FH,18H,18H,18H,18H,18H,18H,18H,0FFH,18H,18H,18H
  .DB   18H,18H,18H,18H,0F8H,18H,18H,18H,18H,18H,18H,18H,1FH,00H,00H,00H
  .DB   18H,18H,18H,18H,0FFH,00H,00H,00H,18H,18H,18H,18H,0F8H,00H,00H,00H
  .DB   00H,00H,00H,00H,0FFH,00H,00H,00H,18H,18H,18H,18H,18H,18H,18H,18H

TAB_THAI:
  .DB   00H,00H,00H,00H,00H,00H,00H,00H
  .DB  00H,7CH,0C2H,22H,42H,42H,42H,42H ; 
  .DB   00H,68H,68H,28H,28H,28H,28H,78H,00H,3CH,42H,5AH,5AH,52H,22H,22H
  .DB   00H,0A2H,0E2H,0A2H,22H,72H,0AAH,66H,00H,0CH,14H,0CH,44H,24H,14H,0CH
  .DB   00H,78H,84H,04H,34H,34H,14H,08H,00H,78H,84H,04H,64H,6CH,36H,26H
  .DB   06H,68H,70H,28H,28H,28H,28H,78H,02H,0B4H,0D8H,0A8H,28H,28H,28H,78H
  .DB   00H,0F2H,4AH,8AH,8AH,8AH,0DEH,0DAH,00H,0F2H,4AH,8AH,8AH,8EH,0C0H,0CEH
  .DB   00H,78H,24H,44H,44H,0C4H,0D4H,2CH,00H,0F8H,44H,44H,44H,84H,54H,0ACH
  .DB   7CH,80H,78H,04H,14H,0CH,0D4H,28H,00H,0A6H,0EAH,32H,22H,22H,22H,22H
  .DB   00H,52H,0AAH,8AH,0AAH,0CAH,5EH,5AH,00H,0E4H,54H,94H,94H,94H,0DEH,0D6H
  .DB   00H,78H,84H,84H,0B4H,0A4H,44H,44H,00H,48H,0B4H,84H,0B4H,0A4H,44H,44H
  .DB   00H,7CH,0C2H,22H,42H,42H,62H,62H,00H,0CCH,0D2H,62H,42H,42H,42H,42H
  .DB   00H,7AH,84H,0F0H,08H,44H,44H,0FCH,00H,0C4H,0C4H,44H,44H,4EH,56H,66H
  .DB   00H,0C2H,0C2H,42H,42H,42H,42H,7EH,02H,0C2H,0C2H,42H,42H,42H,42H,7EH
  .DB   00H,0C2H,0C2H,82H,92H,92H,0AAH,44H,02H,0C2H,0C2H,92H,92H,92H,0AAH,44H
  .DB   00H,0C2H,0C2H,52H,92H,92H,0AAH,44H,02H,0C2H,0C2H,52H,92H,92H,0AAH,44H
  .DB   00H,7CH,0C2H,22H,42H,42H,0C2H,0C2H,00H,62H,62H,22H,22H,72H,6AH,66H
  .DB   00H,62H,62H,42H,32H,42H,42H,0FEH,00H,7AH,84H,0F8H,04H,04H,0CH,0CH
  .DB   00H,7CH,0C2H,22H,42H,42H,62H,02H,00H,7CH,82H,22H,52H,4AH,66H,62H
  .DB   00H,7CH,82H,02H,02H,02H,06H,06H,02H,7CH,82H,0B2H,0B2H,0A2H,42H,42H
  .DB   00H,0C4H,0C4H,54H,5EH,44H,44H,0FCH,02H,7CH,8AH,22H,52H,4AH,66H,62H
  .DB   00H,0CCH,0D2H,4CH,52H,62H,42H,42H,0DH,0D2H,0CCH,42H,92H,92H,0AAH,44H
  .DB   00H,7CH,82H,02H,62H,62H,42H,0FEH,02H,7AH,84H,0FAH,02H,62H,42H,0FEH
  .DB   00H,00H,64H,78H,00H,64H,78H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  .DB   00H,3CH,42H,02H,02H,02H,02H,02H,40H,0ACH,42H,02H,02H,02H,02H,02H
  .DB   00H,20H,20H,20H,20H,20H,30H,30H,00H,48H,48H,48H,48H,48H,6CH,6CH
  .DB   7CH,80H,0E0H,10H,10H,10H,10H,18H,78H,84H,0A4H,48H,08H,08H,0CH,0CH
  .DB   88H,54H,24H,04H,04H,04H,06H,06H,00H,68H,94H,44H,04H,04H,08H,70H
  .DB   00H,64H,4CH,34H,04H,04H,04H,78H

  .DB   00H,18H,08H,00H,00H,00H,00H,00H         ; 
  .DB   00H,34H,1CH,00H,00H,00H,00H,00H         ; 
  .DB   00H,00H,00H,00H,38H,44H,42H,7EH         ; 
  .DB   00H,00H,00H,00H,32H,4AH,46H,7EH         ; 
  .DB   00H,00H,00H,00H,64H,9AH,8AH,0FCH        ; 
  .DB   00H,00H,00H,00H,6AH,9AH,8AH,0FEH        ; 
  .DB   00H,00H,00H,00H,22H,52H,44H,38H         ; 
  .DB   00H,00H,00H,00H,00H,0CH,12H,0CH         ; 
  .DB   00H,00H,02H,02H,3CH,40H,54H,6CH         ; 
  .DB   00H,00H,00H,04H,04H,00H,00H,00H         ; 
  .DB   00H,00H,00H,02H,62H,24H,78H,00H         ; 
  .DB   00H,00H,02H,52H,0AAH,8CH,50H,00H        ; 
  .DB   00H,00H,00H,10H,10H,7CH,10H,10H         ; 
  .DB   00H,00H,02H,02H,0CH,10H,14H,08H         ; 
  .DB   00H,00H,00H,00H,00H,00H,00H,00H         ;
  .DB   00H,04H,04H,04H,00H,0CH,12H,0CH         ;
  .DB   02H,62H,24H,78H,00H,0CH,12H,0CH         ;
  .DB   52H,0AAH,8CH,50H,00H,18H,24H,18H,00H,04H,0EH,04H,00H,0CH,12H,0CH
  .DB   04H,04H,04H,00H,22H,52H,44H,38H,02H,32H,14H,38H,22H,52H,44H,38H
  .DB   52H,0AAH,8CH,58H,44H,0A4H,88H,70H,00H,08H,1CH,08H,22H,52H,44H,38H
  .DB   00H,02H,02H,02H,38H,44H,42H,7EH,02H,62H,24H,78H,38H,44H,42H,7EH
  .DB   52H,0AAH,86H,4CH,38H,44H,42H,7EH,00H,04H,0EH,04H,38H,44H,42H,7EH
  .DB   02H,04H,0AH,0CH,38H,44H,42H,7EH,00H,02H,02H,00H,32H,4AH,46H,7EH
  .DB   02H,32H,14H,38H,32H,4AH,46H,7EH,00H,52H,0AAH,4CH,32H,4AH,46H,7EH
  .DB   04H,0EH,04H,00H,32H,4AH,46H,7EH,00H,04H,04H,00H,64H,9AH,8AH,0FEH
  .DB   02H,32H,14H,38H,64H,9AH,8AH,0FEH,02H,2AH,56H,24H,64H,9AH,8AH,0FEH
  .DB   04H,0EH,04H,00H,64H,9AH,8AH,0FEH,00H,04H,04H,00H,6AH,9AH,8AH,0FEH
  .DB   02H,32H,14H,38H,6AH,9AH,8AH,0FEH,02H,2AH,56H,24H,6AH,9AH,8AH,0FEH
  .DB   04H,0EH,04H,00H,6AH,9AH,8AH,0FEH,00H,00H,00H,00H,00H,00H,00H,00H
;
;
;************
;* RAM AREA *
;************
;
;
            .ORG 8000H
;
X_BUF:      .RS  4 ;1
Y_BUF:      .RS  4 ;1
;
CPORT:      .RS  1
DPORT:      .RS  1
RPORT:      .RS  1
STBMAP:     .RS  2
;
SAVE_HL:    .RS  2
;
COUN_DIS:   .RS  1
P_DIS1:     .RS  2
P_DIS2:     .RS  2
;
BUF_DIS1:   .RS  8*COUN_C
BUF_DIS2:   .RS  8*COUN_C
;
            .END

